''
'' test.bas -- shows the speed up in the floating-point calcs after
''             the FWAIT bug be fixed
''             
'' to make: bc /o test;
''          link test+lib\ffix,,nul,bcom45;
''
'' to run : qb test /l lib\ffix
''
'' obs: if you want run this test more than one time using the IDE,
''      you must reload the IDE or the difference will be 0% as QB
''      only parses the code when it is loaded or changed (thus the
''      fix ups will continue applying)

deflng a-z
const SECONDS = 3%                      '' seconds to measure

declare sub ffix ()

declare function test ()
declare function timer2 ()

  def seg = &h40                        '' point to BIOS data area segment

  print "doing the tests. wait"; 2*SECONDS; "seconds"
  
  test0 = test
  
  ffix                                  '' do the magic :)

  test1 = test

  print "diff:"; ((test1 * 100) \ test0) - 100; "% faster"

'':::
function test static

  calcs = 0

  c# = 1                                '' avoid div by 0

  delay = timer2 + cint(18.2 * SECONDS)

  do
     a# = b# + c#
     a# = b# - c#
     a# = b# * c#
     a# = b# / c#
     calcs = calcs + 1
  loop until (timer2 >= delay)

  test = calcs \ SECONDS
end function

'':::
function timer2 static

  lsw = (peek(&h6d) * 256&) + peek(&h6c)
  msw = (peek(&h6f) * 256&) + peek(&h6e)

  timer2 = (msw * 65536) + lsw
end function
